#!/usr/bin/env python

"""
Converts a header file full of consts (as enums) into a Python module of consts.
"""

import time

SOURCE = "/System/Library/Frameworks/IOKit.framework/Headers/hid/IOHIDUsageTables.h"
DEST = "PyHID/consts.py"

output = file(DEST,'w')
print >>output, "# Automatically generated file -- do not edit"
print >>output, "# Created on %s from %s" % (time.strftime('%c'), SOURCE)
print >>output

enumming = False;
for line in file(SOURCE,'rU'):
    line = line.strip()
    if enumming:
        if line.startswith('}'):
            enumming = False
            print >>output
        else:
            if '=' in line:
                before, after = line.split('=',1)
                token = before.strip()
                after = after.strip()
                if '//' in after:
                    value, comment = after.split('//',1)
                    comment=' # '+comment
                elif '/*' in after:
                    value, comment = after.split('/*',1)
                    comment = ' # '+comment.split('*/',1)[0].strip()
                else:
                    value = after
                    comment = ""
                value=value.strip()
                if value.endswith(','):
                    value=value[:-1].strip()
                print >>output, '%s = %s%s' % (token, value, comment)
    else:
        if line.startswith('enum'):
            enumming = True
            
output.close()