#!/usr/bin/env python

from distutils.core import setup, Extension

module1 = Extension('lowlevel',
                    define_macros = [('MAJOR_VERSION', '1'),
                                     ('MINOR_VERSION', '0')],
                    libraries = ["IOKit"],
                    sources = ['PyHID.cpp', 'HID.cpp'],
                    depends = ['HID.h']
                    )

setup (name = 'PyHID',
       version = '1.0',
       description = 'USB Human Interface Device API for Python',
       author = 'Canis Lupus',
       author_email = 'sorry_i_dont_want_my_email_harvested@mailinator.com',
       url = 'http://www.wooji-juice.com/free/pyhid',
       long_description = '''
This is a library for accessing USB Human Interface Devices (HIDs) on Mac OS X, from
within C++ or Python. Its philosophy is somewhat inspired by the SWT widget libraries for
Java, in that it provides only very simple, low-level native APIs in C, getting as
quickly as possible into a high-level language to provide clean, friendly APIs there.
''',
       packages = ['PyHID', 'PyHID.specific'],
       ext_package='PyHID',
       ext_modules = [module1])
